# Class KMLSublayerExtension

Extends the capabilities of an Esri KMLSublayer object.

#### Hierarchy (view full)

- SublayerExtension<KMLSublayerExtensionProperties>
  - KMLSublayerExtension

#####
Index

### Constructors

constructor

### Properties

_effectiveFullExtent
_handles
_id
_itemType
@eventTypes
iconUrl?
layerListSettings
onAddFeature?
onEditFeature?
queryService?
factory

### Accessors

canChangeDefinitionExpression
canChangeLabels
canChangeOpacity
canChangeRenderer
canChangeScale
canToggleVisibility
capabilities
effectiveFullExtent
effectiveMaxScale
effectiveMinScale
failureMode
featureActions
featureSettings
featureSourceActions
hasFeatures
hyperlinks
id
initialDefinitionExpression
initialRenderer
initialVisibility
isDestroyed
isEffectivelyVisible
isInitialized
itemType
layerExtension
parentSublayerExtension
relationships
renderer
schema
sublayer
sublayerExtensions
supportsSublayers
taskSettings
title
visibilityMode

### Methods

_addAttachment
_addFeatures
_applySublayerProperties
_capabilities
_createFeatureSettings
_createHyperlinks
_createLayerListSettings
_createRelationships
_createSchema
_createSublayer
_createSublayerExtension
_createSublayerExtensionCollection
_createSublayerRef
_createTaskSettings
_deleteAttachments
_deleteFeatures
_getAttachments
_getFeatures
_getSerializableProperties
_initializableChildCollections
_initializeChildren
_isRelationship
_isSupportedSublayer
_onDestroy
_onInitialize
_onSublayerAddedPostInitialize
_postInitialize
_serializeSublayer
_toPropertyDef
_updateFeatures
_watchSublayerProperties
addAttachment
addFeature
addFeatures
assignProperties
assignPropertiesAsync
deleteAttachments
deleteFeature
deleteFeatures
destroy
finishAssignProperties
getAttachments
getDefault
getDefaults
getFeature
getFeatures
getFullExtent
getSerializableProperties
initialize
toItemUri
toJSON
updateFeature
updateFeatures
create

##
Constructors

### constructor

- new KMLSublayerExtension(properties?): KMLSublayerExtension

- #### Parameters

  - `Optional` properties: KMLSublayerExtensionProperties

  #### Returns KMLSublayerExtension

  Overrides SublayerExtension.constructor

##
Properties

### `Protected`_effectiveFullExtent

_effectiveFullExtent: Extent

See mapping/_SublayerExtension!SublayerExtension.effectiveFullExtent.

Inherited from SublayerExtension._effectiveFullExtent

### `Protected` `Readonly`_handles

_handles: Handles<unknown, ResourceHandle>

Inherited from SublayerExtension._handles

### `Protected`_id

_id: string

The unique ID for this entity. Once set, this should never change.

Inherited from SublayerExtension._id

### `Protected` `Readonly`_itemType

_itemType: string = ItemType.SUBLAYER_EXTENSION

The item type for this entity when it participates in an App.

Inherited from SublayerExtension._itemType

### @eventTypes

@eventTypes: InitializableBaseEvents

#### Deprecated

Do not directly reference this property. Use EventNames and EventTypes helpers from @arcgis/core/Evented.

Inherited from SublayerExtension.@eventTypes

### `Optional` iconUrl

iconUrl?: string

URL to an icon that represents this feature source.

Inherited from SublayerExtension.iconUrl

### `Readonly` layerListSettings

layerListSettings: LayerListSettings

Settings that affect the behavior and presentation of the sublayer in the layer list.

Inherited from SublayerExtension.layerListSettings

### `Optional` onAddFeature

onAddFeature?: Action

The action to be executed when a feature is added.

Inherited from SublayerExtension.onAddFeature

### `Optional` onEditFeature

onEditFeature?: Action

The action to be executed when a feature is edited.

Inherited from SublayerExtension.onEditFeature

### `Optional` queryService

queryService?: QueryService

An optional query service that the feature source can use to get features.

Inherited from SublayerExtension.queryService

### `Static` factory

factory: SublayerExtensionFactory

The factory that will be used whenever a new sublayer extension needs to be created. Applications can supply their own factory to customize sublayer extension creation.

Inherited from SublayerExtension.factory

##
Accessors

### canChangeDefinitionExpression

- get canChangeDefinitionExpression(): boolean

- Determines whether the type of sublayer being extended supports changing its definition expression.

  #### Returns boolean

  Inherited from SublayerExtension.canChangeDefinitionExpression

### canChangeLabels

- get canChangeLabels(): boolean

- Determines whether the type of sublayer being extended supports changing labels. Default is false.

  #### Returns boolean

  Inherited from SublayerExtension.canChangeLabels

### canChangeOpacity

- get canChangeOpacity(): boolean

- Determines whether the type of sublayer being extended supports changing opacity. Sublayers belonging to tiled layers cannot have their opacity changed, for example. The default is true.

  #### Returns boolean

  Inherited from SublayerExtension.canChangeOpacity

### canChangeRenderer

- get canChangeRenderer(): boolean

- Determines whether the type of sublayer being extended supports changing its renderer.

  #### Returns boolean

  Inherited from SublayerExtension.canChangeRenderer

### canChangeScale

- get canChangeScale(): boolean

- Determines whether the type of sublayer being extended supports changing Scale. Sublayers belonging to tiled layers cannot have their scale changed, for example. The default is true.

  #### Returns boolean

  Overrides SublayerExtension.canChangeScale

### canToggleVisibility

- get canToggleVisibility(): boolean

- Determines whether the type of sublayer being extended supports toggling visibility. Sublayers belonging to tiled layers cannot have their visibilities toggled, for example. The default is true.

  #### Returns boolean

  Inherited from SublayerExtension.canToggleVisibility

### capabilities

- get capabilities(): QuerySourceCapabilities

- Capabilities of the feature source.

  #### Returns QuerySourceCapabilities

  Inherited from SublayerExtension.capabilities

### effectiveFullExtent

- get effectiveFullExtent(): Extent

- The effective full extent of this sublayer extension.

  #### Returns Extent

  Inherited from SublayerExtension.effectiveFullExtent

### effectiveMaxScale

- get effectiveMaxScale(): number

- The effective max scale for this sublayer extension.

  #### Returns number

  Inherited from SublayerExtension.effectiveMaxScale

### effectiveMinScale

- get effectiveMinScale(): number

- The effective min scale for this sublayer extension.

  #### Returns number

  Inherited from SublayerExtension.effectiveMinScale

### failureMode

- get failureMode(): FailureMode

- Determines how a parent object should handle initialization failure in this object. The default is "warn".

  - `"error"`: support/InitializeError!InitializeError is thrown.
  - `"warn"`: Message is logged and support/InitializableBase!InitializeWarningEvent is raised.
  - `"ignore"`: support/InitializableBase!InitializeWarningEvent is raised.

  #### Returns FailureMode

  Inherited from SublayerExtension.failureMode

- set failureMode(value): void

- #### Parameters

  - value: FailureMode

  #### Returns void

  Inherited from SublayerExtension.failureMode

### featureActions

- get featureActions(): Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

- A menu for actions specifically related to features from this source.

  #### Returns Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  Inherited from SublayerExtension.featureActions

- set featureActions(value): void

- A menu for actions specifically related to features from this source.

  #### Parameters

  - value: Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  #### Returns void

  Inherited from SublayerExtension.featureActions

### featureSettings

- get featureSettings(): FeatureSettings

- Default settings that apply to features originating from this source.

  #### Returns FeatureSettings

  Inherited from SublayerExtension.featureSettings

### featureSourceActions

- get featureSourceActions(): Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

- A menu for actions specifically related to this source.

  #### Returns Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  Inherited from SublayerExtension.featureSourceActions

- set featureSourceActions(value): void

- A menu for actions specifically related to this source.

  #### Parameters

  - value: Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  #### Returns void

  Inherited from SublayerExtension.featureSourceActions

### hasFeatures

- get hasFeatures(): boolean

- Determines whether this type of layer is capable of producing features.

  #### Returns boolean

  Overrides SublayerExtension.hasFeatures

### hyperlinks

- get hyperlinks(): Collection<Hyperlink>

- Hyperlinks associated with the feature source.

  #### Returns Collection<Hyperlink>

  Inherited from SublayerExtension.hyperlinks

### id

- get id(): string

- The unique ID for this entity.

  #### Returns string

  Inherited from SublayerExtension.id

### initialDefinitionExpression

- get initialDefinitionExpression(): string

- String value containing the initial definition expression configured on the layer.

  #### Returns string

  Inherited from SublayerExtension.initialDefinitionExpression

### initialRenderer

- get initialRenderer(): Renderer

- A clone of the initial renderer, if any, that the ESRI layer uses to display data on the map.

  #### Returns Renderer

  Inherited from SublayerExtension.initialRenderer

### initialVisibility

- get initialVisibility(): boolean

- Indicates the initial layer visibility.

  #### Returns boolean

  Inherited from SublayerExtension.initialVisibility

### isDestroyed

- get isDestroyed(): boolean

- See support/InitializableBase!Initializable.isDestroyed.

  #### Returns boolean

  Inherited from SublayerExtension.isDestroyed

### isEffectivelyVisible

- get isEffectivelyVisible(): boolean

- The effective visibility for this sublayer extension.

  #### Returns boolean

  Inherited from SublayerExtension.isEffectivelyVisible

### isInitialized

- get isInitialized(): boolean

- See support/InitializableBase!Initializable.isInitialized.

  #### Returns boolean

  Inherited from SublayerExtension.isInitialized

### itemType

- get itemType(): string

- The item type for this entity when it participates in an App.

  #### Returns string

  Inherited from SublayerExtension.itemType

### layerExtension

- get layerExtension(): KMLLayerExtension

- The layer extension that this sublayer extension belongs to.

  #### Returns KMLLayerExtension

  Overrides SublayerExtension.layerExtension

### parentSublayerExtension

- get parentSublayerExtension(): SublayerExtension<SublayerExtensionProperties>

- The sublayer extension that this sublayer extension belongs to.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtension.parentSublayerExtension

### relationships

- get relationships(): Collection<Relationship>

- Relationships to other feature sources.

  #### Returns Collection<Relationship>

  Inherited from SublayerExtension.relationships

### renderer

- get renderer(): RendererUnion

- The renderer, if any, that the ESRI sublayer uses to display data on the map.

  #### Returns RendererUnion

  Inherited from SublayerExtension.renderer

### schema

- get schema(): Schema

- Metadata about features originating from this source, such as fields, domains, and geometry type.

  #### Returns Schema

  Inherited from SublayerExtension.schema

### sublayer

- get sublayer(): KMLSublayer

- The sublayer that is being extended.

  #### Returns KMLSublayer

  Overrides SublayerExtension.sublayer

### sublayerExtensions

- get sublayerExtensions(): KMLSublayerExtensionCollection

- The sublayer extensions associated with each sublayer of this sublayer.

  #### Returns KMLSublayerExtensionCollection

  Overrides SublayerExtension.sublayerExtensions

### supportsSublayers

- get supportsSublayers(): boolean

- Determines whether this type of sublayer is capable of having sublayers.

  #### Returns boolean

  Overrides SublayerExtension.supportsSublayers

### taskSettings

- get taskSettings(): TaskSettings

- Settings that affect whether a feature source participates in various tasks that are performed on a map.

  #### Returns TaskSettings

  Inherited from SublayerExtension.taskSettings

### title

- get title(): string

- See data/FeatureSource!FeatureSource.title.

  #### Returns string

  Inherited from SublayerExtension.title

### visibilityMode

- get visibilityMode(): GroupLayerVisibilityMode

- Indicates how to manage the visibility of the children layers.

  #### Returns GroupLayerVisibilityMode

  Inherited from SublayerExtension.visibilityMode

- set visibilityMode(value): void

- #### Parameters

  - value: GroupLayerVisibilityMode

  #### Returns void

  Inherited from SublayerExtension.visibilityMode

##
Methods

### `Protected`_addAttachment

- _addAttachment(feature, attachment): Promise<Attachment>

- Called to add an attachment to a feature. Subclasses must override this if they support feature attachments.

  #### Parameters

  - feature: Feature

    The feature to add the attachment to.

  - attachment: AttachmentProperties | Attachment | File

    The attachment to add to the feature.

  #### Returns Promise<Attachment>

  Inherited from SublayerExtension._addAttachment

### `Protected`_addFeatures

- _addFeatures(features, options?): Promise<void>

- Called to add new features. Subclasses must override this if they support adding features.

  #### Parameters

  - features: Iterable<Feature, any, any>

    The features to add.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from SublayerExtension._addFeatures

### `Protected`_applySublayerProperties

- _applySublayerProperties(properties, sublayer): Promise<void>

- Called to apply properties to the sublayer for this sublayer extension.

  #### Parameters

  - properties: SublayerProperties
  - sublayer: KMLSublayer

  #### Returns Promise<void>

  Overrides SublayerExtension._applySublayerProperties

### `Protected`_capabilities

- _capabilities(): QuerySourceCapabilities

- The capabilities of the feature source.

  #### Returns QuerySourceCapabilities

  Overrides SublayerExtension._capabilities

### `Protected`_createFeatureSettings

- _createFeatureSettings(): FeatureSettings

- Called to create the data/FeatureSettings!FeatureSettings for this feature source.

  #### Returns FeatureSettings

  Inherited from SublayerExtension._createFeatureSettings

### `Protected`_createHyperlinks

- _createHyperlinks(): Collection<Hyperlink>

- Called to create the Hyperlink collection for this feature source.

  #### Returns Collection<Hyperlink>

  Inherited from SublayerExtension._createHyperlinks

### `Protected`_createLayerListSettings

- _createLayerListSettings(properties?): LayerListSettings

- Called to create the mapping/support/LayerListSettings!LayerListSettings for this sublayer extension.

  #### Parameters

  - `Optional` properties: LayerListSettingsProperties

    Properties used to initialize the layer list settings.

  #### Returns LayerListSettings

  Inherited from SublayerExtension._createLayerListSettings

### `Protected`_createRelationships

- _createRelationships(): Collection<Relationship>

- Called to create the data/_Relationship!Relationship collection for this feature source.

  #### Returns Collection<Relationship>

  Inherited from SublayerExtension._createRelationships

### `Protected`_createSchema

- _createSchema(): Schema

- Called to create the data/Schema!Schema for this feature source.

  #### Returns Schema

  Inherited from SublayerExtension._createSchema

### `Protected`_createSublayer

- _createSublayer(_properties): KMLSublayer

- Called to create the sublayer for this sublayer extension.

  #### Parameters

  - _properties: SublayerProperties

  #### Returns KMLSublayer

  Overrides SublayerExtension._createSublayer

### `Protected`_createSublayerExtension

- _createSublayerExtension(properties?): KMLSublayerExtension

- Called to create a child sublayer extension.

  #### Parameters

  - `Optional` properties: KMLSublayerExtensionProperties

    Properties used to initialize the sublayer extension.

  #### Returns KMLSublayerExtension

  Overrides SublayerExtension._createSublayerExtension

### `Protected`_createSublayerExtensionCollection

- _createSublayerExtensionCollection(): SubSublayerExtensionCollection

- Called to create the mapping/support/_SublayerExtensionCollection!SublayerExtensionCollection for this sublayer extension.

  #### Returns SubSublayerExtensionCollection

  Overrides SublayerExtension._createSublayerExtensionCollection

### `Protected`_createSublayerRef

- _createSublayerRef(): SublayerProperties

- Creates a $ref for the this sublayer extension's sublayer.

  #### Returns SublayerProperties

  Inherited from SublayerExtension._createSublayerRef

### `Protected`_createTaskSettings

- _createTaskSettings(): TaskSettings

- Called to create the data/TaskSettings!TaskSettings for this feature source.

  #### Returns TaskSettings

  Inherited from SublayerExtension._createTaskSettings

### `Protected`_deleteAttachments

- _deleteAttachments(feature, attachments): Promise<void>

- Called to remove attachments from a feature. Subclasses must override this if they support feature attachments.

  #### Parameters

  - feature: Feature

    The feature to delete attachments from.

  - attachments: (string | Attachment)[]

    The attachments or the IDs of the attachments to delete.

  #### Returns Promise<void>

  Inherited from SublayerExtension._deleteAttachments

### `Protected`_deleteFeatures

- _deleteFeatures(ids, options?): Promise<void>

- Called to delete features. Subclasses must override this if they support deleting features.

  #### Parameters

  - ids: string[]

    The IDs of the features to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from SublayerExtension._deleteFeatures

### `Protected`_getAttachments

- _getAttachments(feature): Promise<Attachment[]>

- Called to retrieve attachments for a feature. Subclasses must override this if they support feature attachments.

  #### Parameters

  - feature: Feature

    The feature to get attachments for.

  #### Returns Promise<Attachment[]>

  Inherited from SublayerExtension._getAttachments

### `Protected`_getFeatures

- _getFeatures(ids, options?): AsyncIterable<Feature, any, any>

- Called to retrieve features. Subclasses must override this if they support querying for features.

  #### Parameters

  - ids: string[]

    The unique IDs of features to retrieve.

  - `Optional` options: FeatureReadOptions

    Options that control what gets returned.

  #### Returns AsyncIterable<Feature, any, any>

  Inherited from SublayerExtension._getFeatures

### `Protected`_getSerializableProperties

- _getSerializableProperties(): PropertyDefs<KMLSublayerExtensionProperties>

- The property keys and their metadata that are used to implement serializing and deserializing the class instance.

  #### Returns PropertyDefs<KMLSublayerExtensionProperties>

  Inherited from SublayerExtension._getSerializableProperties

### `Protected`_initializableChildCollections

- _initializableChildCollections(): IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

- Collections of child items to initialize. Items that fail to initialize are removed from the collection.

  #### Returns IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

  Inherited from SublayerExtension._initializableChildCollections

### `Protected`_initializeChildren

- _initializeChildren(): Promise<void>

- Initializes child entities.

  #### Returns Promise<void>

  Inherited from SublayerExtension._initializeChildren

### `Protected`_isRelationship

- _isRelationship(relationship): boolean

- #### Parameters

  - relationship: Relationship | RelationshipProperties

  #### Returns boolean

  Inherited from SublayerExtension._isRelationship

### `Protected`_isSupportedSublayer

- _isSupportedSublayer(sublayer): boolean

- Determines whether the sublayer is of the right type for the type of sublayer extension.

  #### Parameters

  - sublayer: SublayerLike

    The sublayer to validate.

  #### Returns boolean

  Overrides SublayerExtension._isSupportedSublayer

### `Protected`_onDestroy

- _onDestroy(): Promise<void>

- Called to perform cleanup. Subclasses should override this method rather than destroy() to perform custom cleanup.

  #### Returns Promise<void>

  Inherited from SublayerExtension._onDestroy

### `Protected`_onInitialize

- _onInitialize(): Promise<void>

- Called to perform initialization of the support/InitializableBase!InitializableBase. Subclasses should override this method rather than initialize() to perform custom initialization.

  #### Returns Promise<void>

  Inherited from SublayerExtension._onInitialize

### `Protected` `Readonly`_onSublayerAddedPostInitialize

- _onSublayerAddedPostInitialize(sublayerX): Promise<void>

- A callback executed when a sublayer is added as a child of the LayerExtension, after the LayerExtension has been initialized.

  #### Parameters

  - sublayerX: SublayerExtension<SublayerExtensionProperties>

    The sublayer that was added.

  #### Returns Promise<void>

  Inherited from SublayerExtension._onSublayerAddedPostInitialize

### `Protected`_postInitialize

- _postInitialize(): Promise<void>

- Called after normal initialization. Note: Child items are initialized before this is called.

  #### Returns Promise<void>

  Inherited from SublayerExtension._postInitialize

### `Protected`_serializeSublayer

- _serializeSublayer(_sublayer): SublayerProperties

- Serializes a sublayer.

  #### Parameters

  - _sublayer: KMLSublayer

    The sublayer to serialize.

  #### Returns SublayerProperties

  Overrides SublayerExtension._serializeSublayer

### `Protected`_toPropertyDef

- _toPropertyDef<T>(def): PropertyDef<T>

- Converts the value to a PropertyDef object.

  #### Type Parameters

  - T

  #### Parameters

  - def: PropertyDefSerializeMode | PropertyDefSerializeMode[] | PropertyDef<T>

    The value to convert.

  #### Returns PropertyDef<T>

  Inherited from SublayerExtension._toPropertyDef

### `Protected`_updateFeatures

- _updateFeatures(features, options?): Promise<void>

- Called to update features. Subclasses must override this if they support updating features.

  #### Parameters

  - features: Iterable<Feature, any, any>

    The feature to update.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from SublayerExtension._updateFeatures

### `Protected`_watchSublayerProperties

- _watchSublayerProperties(): void

- Watches for changes on sublayer properties.

  #### Returns void

  Inherited from SublayerExtension._watchSublayerProperties

### addAttachment

- addAttachment(feature, attachment): Promise<Attachment>

- Adds an attachment to a feature.

  #### Parameters

  - feature: Feature

    The feature to add the attachment to.

  - attachment: AttachmentProperties | Attachment | File

    The attachment to add to the feature.

  #### Returns Promise<Attachment>

  Inherited from SublayerExtension.addAttachment

### addFeature

- addFeature(feature, _options?): Promise<void>

- Adds a new feature to the source. If the source does not support adding features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - feature: Feature

    The feature to add.

  - `Optional`_options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from SublayerExtension.addFeature

### addFeatures

- addFeatures(features, options?): Promise<void>

- Adds a set of features to the source. If the source does not support adding features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - features: FeatureSet

    The features to add.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are saved.

  #### Returns Promise<void>

  Inherited from SublayerExtension.addFeatures

### assignProperties

- assignProperties(properties): void

- #### Parameters

  - properties: Partial<KMLSublayerExtensionProperties>

  #### Returns void

  #### Inherit Doc

  Inherited from SublayerExtension.assignProperties

### assignPropertiesAsync

- assignPropertiesAsync(properties): Promise<void>

- #### Parameters

  - properties: Partial<KMLSublayerExtensionProperties>

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from SublayerExtension.assignPropertiesAsync

### deleteAttachments

- deleteAttachments(feature, attachments): Promise<void>

- Deletes attachments from a feature.

  #### Parameters

  - feature: Feature

    The feature to delete attachments from.

  - attachments: (string | Attachment)[]

    The attachments or the IDs of the attachments to delete from the feature.

  #### Returns Promise<void>

  Inherited from SublayerExtension.deleteAttachments

### deleteFeature

- deleteFeature(id, options?): Promise<void>

- Deletes a feature from its source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - id: string

    The ID of the feature to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from SublayerExtension.deleteFeature

- deleteFeature(feature, options?): Promise<void>

- Deletes a feature from its source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - feature: Feature

    The feature to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from SublayerExtension.deleteFeature

### deleteFeatures

- deleteFeatures(ids, options?): Promise<void>

- Deletes features from their source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - ids: Iterable<string, any, any>

    The IDs of the features to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from SublayerExtension.deleteFeatures

- deleteFeatures(features, options?): Promise<void>

- Deletes features from their source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - features: Iterable<Feature, any, any>

    The features to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from SublayerExtension.deleteFeatures

### destroy

- destroy(): Promise<void>

- A clean-up function that should get called whenever the item is disposed of.

  #### Returns Promise<void>

  Inherited from SublayerExtension.destroy

### finishAssignProperties

- finishAssignProperties(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from SublayerExtension.finishAssignProperties

### getAttachments

- getAttachments(feature): Promise<Attachment[]>

- Gets any attachments associated with a feature.

  #### Parameters

  - feature: Feature

    The feature to get attachments for.

  #### Returns Promise<Attachment[]>

  Inherited from SublayerExtension.getAttachments

### getDefault

- getDefault<K>(key): KMLSublayerExtensionProperties[K]

- #### Type Parameters

  - K extends keyof KMLSublayerExtensionProperties

  #### Parameters

  - key: K

  #### Returns KMLSublayerExtensionProperties[K]

  #### Inherit Doc

  Inherited from SublayerExtension.getDefault

### getDefaults

- getDefaults(): KMLSublayerExtensionProperties

- #### Returns KMLSublayerExtensionProperties

  #### Inherit Doc

  Inherited from SublayerExtension.getDefaults

### getFeature

- getFeature(id, options?): Promise<Feature>

- Gets a feature by ID. If no such feature exists, the promise is rejected with an instance of NotFoundError.

  #### Parameters

  - id: string

    The ID of the feature to retrieve.

  - `Optional` options: FeatureReadOptions

    Additional options that control how the feature is retrieved.

  #### Returns Promise<Feature>

  Inherited from SublayerExtension.getFeature

### getFeatures

- getFeatures(ids, options?): AsyncIterable<Feature, any, any>

- Gets a set of features by their IDs.

  #### Parameters

  - ids: string[]

    The IDs of the features to retrieve.

  - `Optional` options: FeatureReadOptions

    Additional Options that control how the features are retrieved.

  #### Returns AsyncIterable<Feature, any, any>

  Inherited from SublayerExtension.getFeatures

### getFullExtent

- getFullExtent(): Extent

- Returns the full extent of the source that contains all included features.

  #### Returns Extent

  Inherited from SublayerExtension.getFullExtent

### getSerializableProperties

- getSerializableProperties(serializeMode?): PropertyDefs<KMLSublayerExtensionProperties>

- Returns the serializable properties.

  #### Parameters

  - `Optional` serializeMode: SerializeMode

    Optional. If specified, only properties that support the given serialization mode will be returned.

  #### Returns PropertyDefs<KMLSublayerExtensionProperties>

  Inherited from SublayerExtension.getSerializableProperties

### initialize

- initialize(): Promise<void>

- Initializes the item.

  #### Returns Promise<void>

  Inherited from SublayerExtension.initialize

### toItemUri

- toItemUri(): string

- Creates an item:// URI reference to this entity.

  #### Returns string

  Inherited from SublayerExtension.toItemUri

### toJSON

- toJSON(serializeMode?): KMLSublayerExtensionProperties

- #### Parameters

  - serializeMode: SerializeMode = "all"

  #### Returns KMLSublayerExtensionProperties

  #### Inherit Doc

  Inherited from SublayerExtension.toJSON

### updateFeature

- updateFeature(feature, _options?): Promise<void>

- Saves changes to an existing feature. If the source does not support updating features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - feature: Feature

    The feature to update.

  - `Optional`_options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from SublayerExtension.updateFeature

### updateFeatures

- updateFeatures(features, options?): Promise<void>

- Saves changes to a existing features. If the source does not support updating features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - features: FeatureSet

    The features to update.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are saved.

  #### Returns Promise<void>

  Inherited from SublayerExtension.updateFeatures

### `Static` create

- create(properties): SublayerExtension<SublayerExtensionProperties>

- Creates the appropriate subclass of mapping/_SublayerExtension!SublayerExtension based on the supplied properties. Applications can customize the default creation behavior by supplying a custom factory object (see mapping/_SublayerExtension!SublayerExtension.factory).

  #### Parameters

  - properties: SublayerExtensionProperties

    The sublayer extension properties.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtension.create